#ifndef KINEMATICS_h
#define KINEMATICS_h
/**********************************/
/* a class for general operations */
/**********************************/
//----------------
#include "Moses.h"
//----------------
using namespace std;
using namespace Pythia8;

namespace Moses1 {

class kinematics : public Particle {
	public:
		kinematics();
		~kinematics();
		
		double invMass(Particle &lepton, Particle &alepton);
		double pT(Particle &lepton, Particle &alepton);
		double y(Particle &lepton, Particle &alepton);
		
		bool invMcut(Particle &lepton, Particle &alepton);
		bool pTcut(Particle &lepton, Particle &alepton);
		bool etaCut(Particle &lepton, Particle &alepton);
		bool pTsystemCut(Particle &lepton, Particle &alepton);
		bool ySystemCut(Particle &lepton, Particle &alepton);

		void setCuts(double invMassCut, double pTransverseCut, double EtaCut, double pTsystemCut, double ySystemCut);
		bool applyAllCuts(Particle &lepton, Particle &alepton);

		double getInvMcut();
		double getpTcut();
		double getEtacut();
		double getpTsystemCut();
		double getySystemCut();

	private:
	double m_invMcut, m_pTcut, m_etacut, m_pTsystemCut, m_ySystemCut;
};

}
#endif

