#include "mosesHardProcessRecord.h"

using namespace std;

namespace Moses1 {

mosesHardProcessRecord::mosesHardProcessRecord(string name, TFile* file)
{
	initialize(name, file);
}

mosesHardProcessRecord::~mosesHardProcessRecord(){}

void mosesHardProcessRecord::initialize(string name, TFile* file)
{
	m_name = name;

    m_dir = file->mkdir(m_name.c_str());
	m_dir->cd();
    cout << "built the " << m_name << " dir, ";
	
	/*
	m_momA = new mapTObj;
	m_momB = new mapTObj;
	m_sonA = new mapTObj;
	m_sonB = new mapTObj;
	
	m_isFinal     = new mapTObj;
	m_statusLevel = new mapTObj;
	
	m_id      = new mapTObj;
	m_cg      = new mapTObj;
	m_m0      = new mapTObj;
	m_p0      = new mapTObj;
	m_px      = new mapTObj;
	m_py      = new mapTObj;
	m_px      = new mapTObj;
	m_xVtx    = new mapTObj;
	m_yVtx    = new mapTObj;
	m_zVtx    = new mapTObj;
	*/
	
	m_pythia2mosesIndexMap = new mapTObj;
	
	m_momA = new vector<int>;
	m_momB = new vector<int>;
	m_sonA = new vector<int>;
	m_sonB = new vector<int>;
	
	m_isFinal     = new vector<int>;
	m_statusLevel = new vector<int>;
	
	m_id      = new vector<int>;
	m_cg      = new vector<double>;
	m_m0      = new vector<double>;
	m_p0      = new vector<double>;
	m_px      = new vector<double>;
	m_py      = new vector<double>;
	m_px      = new vector<double>;
	m_xVtx    = new vector<double>;
	m_yVtx    = new vector<double>;
	m_zVtx    = new vector<double>;
	
    string dataTreeName  = name+"Tree";
    string dataTreeTitle = name;
    m_hardProcessDataTree = new TTree(dataTreeName.c_str(),dataTreeTitle.c_str());
	
	
	m_hardProcessDataTree->Branch("pythia2mosesIndexMap", "mapTObj",   &m_pythia2mosesIndexMap);
	
	m_hardProcessDataTree->Branch("momA",   &m_momA);
	m_hardProcessDataTree->Branch("momB",    &m_momB);
	m_hardProcessDataTree->Branch("sonA",    &m_sonA);
	m_hardProcessDataTree->Branch("sonB",    &m_sonB);
	
	m_hardProcessDataTree->Branch("isFinal",     &m_isFinal);
	m_hardProcessDataTree->Branch("statusLevel", &m_statusLevel);
	
    m_hardProcessDataTree->Branch("id", &m_id);
	m_hardProcessDataTree->Branch("cg", &m_cg);
    m_hardProcessDataTree->Branch("m0", &m_m0);
    m_hardProcessDataTree->Branch("p0", &m_p0);
    m_hardProcessDataTree->Branch("px", &m_px);
    m_hardProcessDataTree->Branch("py", &m_py);
    m_hardProcessDataTree->Branch("pz", &m_pz);
    m_hardProcessDataTree->Branch("xVtx", &m_xVtx);
    m_hardProcessDataTree->Branch("yVtx", &m_yVtx);
    m_hardProcessDataTree->Branch("zVtx", &m_zVtx);
	
	/*
	m_hardProcessDataTree->Branch("momA", "mapTObj",   &m_momA);
	m_hardProcessDataTree->Branch("momB", "mapTObj",    &m_momB);
	m_hardProcessDataTree->Branch("sonA", "mapTObj",    &m_sonA);
	m_hardProcessDataTree->Branch("sonB", "mapTObj",    &m_sonB);
	
	m_hardProcessDataTree->Branch("isFinal", "mapTObj",     &m_isFinal);
	m_hardProcessDataTree->Branch("statusLevel", "mapTObj", &m_statusLevel);
	
    m_hardProcessDataTree->Branch("id", "mapTObj", &m_id);
	m_hardProcessDataTree->Branch("cg", "mapTObj", &m_cg);
    m_hardProcessDataTree->Branch("m0", "mapTObj", &m_m0);
    m_hardProcessDataTree->Branch("p0", "mapTObj", &m_p0);
    m_hardProcessDataTree->Branch("px", "mapTObj", &m_px);
    m_hardProcessDataTree->Branch("py", "mapTObj", &m_py);
    m_hardProcessDataTree->Branch("pz", "mapTObj", &m_pz);
    m_hardProcessDataTree->Branch("xVtx", "mapTObj", &m_xVtx);
    m_hardProcessDataTree->Branch("yVtx", "mapTObj", &m_yVtx);
    m_ardProcessDataTree->Branch("zVtx", "mapTObj", &m_zVtx);
	*/
    cout << "data tree " << endl;;
}

bool mosesHardProcessRecord::fillRecordTree()
{
	m_hardProcessDataTree->Fill();
	return true;
}

bool mosesHardProcessRecord::writeRecordTree()
{
	m_dir->cd();
	m_hardProcessDataTree->Write();
	return true;
}

bool mosesHardProcessRecord::clearHardProcessRecord()
{
	m_pythia2mosesIndexMap->clear();
	
	if(m_momA!=NULL && m_momA->size()!=0) m_momA->clear();
	if(m_momB!=NULL && m_momB->size()!=0) m_momB->clear();
	if(m_sonA!=NULL && m_sonA->size()!=0) m_sonA->clear();
	if(m_sonB!=NULL && m_sonB->size()!=0) m_sonB->clear();
	
	if(m_isFinal!=NULL     && m_isFinal->size()!=0)     m_isFinal->clear();
	if(m_statusLevel!=NULL && m_statusLevel->size()!=0) m_statusLevel->clear();
	
	if(m_id!=NULL && m_id->size()!=0) m_id->clear();
	if(m_cg!=NULL && m_cg->size()!=0) m_cg->clear();
	if(m_m0!=NULL && m_m0->size()!=0) m_m0->clear();
	if(m_p0!=NULL && m_p0->size()!=0) m_p0->clear();
	if(m_px!=NULL && m_px->size()!=0) m_px->clear();
	if(m_py!=NULL && m_py->size()!=0) m_py->clear();
	if(m_pz!=NULL && m_pz->size()!=0) m_pz->clear();
	if(m_xVtx!=NULL && m_xVtx->size()!=0) m_xVtx->clear();
	if(m_yVtx!=NULL && m_yVtx->size()!=0) m_yVtx->clear();
	if(m_zVtx!=NULL && m_zVtx->size()!=0) m_zVtx->clear();
	
	/*
	m_momA->clear();
	m_momB->clear();
	m_sonA->clear();
	m_sonB->clear();
	
	m_isFinal->clear();
	m_statusLevel->clear();
	
	m_id->clear();
	m_cg->clear();
	m_m0->clear();
	m_p0->clear();
	m_px->clear();
	m_py->clear();
	m_pz->clear();
	m_xVtx->clear();
	m_yVtx->clear();
	m_zVtx->clear();
	*/
	
	return true;
}

int mosesHardProcessRecord::getStatusLevel(int status)
{
	int absStatus = abs(status);
	int statusLevel = 0;
	// Particle::status() = 21 - 29 : particles of the hardest subprocess
	// Particle::status() = 31 - 39 : particles of subsequent subprocesses
	// Particle::status() = 41 - 49 : particles produced by initial-state-showers
	// Particle::status() = 51 - 59 : particles produced by final-state-showers
	if     ( absStatus<=29 && absStatus>=21 ) statusLevel=1;
	else if( absStatus<=39 && absStatus>=31 ) statusLevel=2; 
    else if( absStatus<=49 && absStatus>=41 ) statusLevel=3;
	else if( absStatus<=59 && absStatus>=51 ) statusLevel=4;
	return statusLevel;
}

bool mosesHardProcessRecord::fillHardProcessRecord(Particle &particle,  int pythiaIndex, int mosesIndex)
{
	//int mosesIndex = (m_id->size()==0) ? 0:(int)m_id->size()-1; // linear...
	m_pythia2mosesIndexMap->insertPair( (int)pythiaIndex, (int)mosesIndex );
	
	m_isFinal->push_back( (particle.isFinal())?1:0 );
	m_statusLevel->push_back( (int)getStatusLevel(particle.status()) );
	
	m_momA->push_back( (int)particle.mother1() );
	m_momB->push_back( (int)particle.mother2() );
	m_sonA->push_back( (int)particle.daughter1() );
	m_sonB->push_back( (int)particle.daughter2() );
	
	m_id->push_back(   (int)particle.id() );
	m_cg->push_back(   particle.charge() );
	m_m0->push_back(   particle.m() );
	m_p0->push_back(   particle.e() );
	m_px->push_back(   particle.px() );
	m_py->push_back(   particle.py() );
	m_pz->push_back(   particle.pz() );
	m_xVtx->push_back( particle.xProd() );
	m_yVtx->push_back( particle.yProd() );
	m_zVtx->push_back( particle.zProd() );
	

	/*
	m_isFinal->insertPair(     (double)index, (particle.isFinal())?1.:0. );
	m_statusLevel->insertPair( (double)index, (double)getStatusLevel(particle.status()) );
	
	m_momA->insertPair( (double)index, (double)particle.mother1() );
	m_momB->insertPair( (double)index, (double)particle.mother2() );
	m_sonA->insertPair( (double)index, (double)particle.daughter1() );
	m_sonB->insertPair( (double)index, (double)particle.daughter2() );
	
	m_id->insertPair(   (double)index, (double)particle.id() );
	m_cg->insertPair(   (double)index, (double)particle.charge() );
	m_m0->insertPair(   (double)index, (double)particle.m() );
	m_p0->insertPair(   (double)index, (double)particle.e() );
	m_px->insertPair(   (double)index, (double)particle.px() );
	m_py->insertPair(   (double)index, (double)particle.py() );
	m_pz->insertPair(   (double)index, (double)particle.pz() );
	m_xVtx->insertPair( (double)index, (double)particle.xProd() );
	m_yVtx->insertPair( (double)index, (double)particle.yProd() );
	m_zVtx->insertPair( (double)index, (double)particle.zProd() );
	*/
	
	return true;
}

}
